/**
 * 模块说明
 * @module 校验组件
 * @author Max.Law 2022/08/26
 */

export default [
  {
    name: '身份证',
    type: 'input',
    grade: 'lego',
    icon: 'el-icon-edit',
    placeholder: '请输入身份证号码',
    formItem: {
      rules: [
        {
          label: '身份证校验',
          message: '请输入正确的身份证号',
          trigger: 'blur',
          validatorCite: 'IdentityCodeValid',
        },
      ],
    },
  },
  {
    name: '邮箱',
    type: 'input',
    grade: 'lego',
    icon: 'el-icon-edit',
    placeholder: '请输入邮箱地址',
    formItem: {
      rules: [
        {
          label: '邮箱校验',
          message: '请输入正确的邮箱地址',
          trigger: 'blur',
          validatorCite: 'checkEmail',
        },
      ],
    },
  },
  {
    name: '手机号',
    type: 'input',
    grade: 'lego',
    icon: 'el-icon-edit',
    placeholder: '请输入手机号',
    formItem: {
      rules: [
        {
          label: '手机号校验',
          message: '请输入正确的手机号',
          trigger: 'blur',
          validatorCite: 'checkPhone',
        },
      ],
    },
  },
  {
    name: '座机号',
    type: 'input',
    grade: 'lego',
    icon: 'el-icon-edit',
    placeholder: '请输入座机号',
    formItem: {
      rules: [
        {
          label: '座机号校验',
          message: '请输入正确的座机号',
          trigger: 'blur',
          validatorCite: 'checkTel',
        },
      ],
    },
  },
  {
    name: '模板引用',
    type: 'dependenceModule',
    grade: 'brick',
    icon: 'el-icon-document-add',
    option: [
      {
        key: 'name',
        value: '默认',
      },
      {
        key: 'formId',
        value: '',
      },
    ],
    formItem: {
      span: 24,
      noLabel: true,
      labelWidth: '0px',
    },
  },
  {
    name: '省市区',
    type: 'form-address',
    grade: 'lego',
    icon: 'el-icon-location-outline',
  },
];
