'use strict';

// 设计器依赖
import FormDesign from './index.vue';
import Components from './components/form/index';
import StoreModule from './store';

let plugins = {};

const componentArray = [FormDesign, ...Components];

plugins.install = function (Vue) {
  // 判断是否安装过
  if (plugins.installed) return;
  plugins.installed = true;

  componentArray.forEach((item) => {
    Vue.component(`bm-${item.name}`, item);
  });
};

export const RiseDesign = plugins;

export const RiseStore = StoreModule;
